<template>
  <div>
    <div @click="openDialog">
      <slot></slot>
    </div>
    <a-modal v-model="isDialogActive" centered :footer="null" :width="1100" :closeable="false">
      <div class="relative mb-8">
        <div class="absolute">
          <b-outline-action-button @click="closeDialog">Back</b-outline-action-button>
        </div>
        <div class="text-center">
          <t-h1 size="text-3xl" weight="bold">VIDEO</t-h1>
        </div>
      </div>
      <div class="text-center mb-6">
        <div v-for="(video, index) in videos" v-show="index === selectedIndex" :key="index" class="p-12 py-10">
          <video controls class="w-full" height="250">
            <source :src="video.bbsVideoUrl" type="video/mp4">
          </video>
        </div>
        <a-radio-group v-model="selectedIndex" button-style="solid">
          <a-radio-button v-for="(video, index) in videos" :key="video.bbsVideoUrl" :value="index">{{getTime(video.startingTime)}} - {{getTime(video.endingTime)}}</a-radio-button>
        </a-radio-group>
        <div class="flex items-center justify-center space-x-2 mt-6">
          <a-time-picker v-model="startTime" format="HH:mm" value-format="HH:mm:ss" placeholder="Start Time" />
          <a-time-picker v-model="endTime" format="HH:mm" value-format="HH:mm:ss" placeholder="End Time" />
          <div class="w-20">
            <b-action-button @click="onFetchVideoImmediately">Filter</b-action-button>
          </div>
        </div>

      </div>
    </a-modal>
  </div>
</template>

<script>
import { defineComponent } from '@nuxtjs/composition-api'
import moment from 'moment'
import TH1 from '~/components/shared/typography/H1'
import BOutlineActionButton from '~/components/shared/buttons/OutlineActionButton'
import { useBuilding } from '~/store/building'
import useAreaVideo from '~/composables/useAreaVideo'
import BActionButton from '~/components/shared/buttons/ActionButton'

export default defineComponent({
  components: { BOutlineActionButton, TH1, BActionButton },
  setup() {
    const store = useBuilding()
    return { store, ...useAreaVideo() }
  },
  data() {
    return {
      selectedIndex: 0,
      isDialogActive: false,
      startTime: this.store.currentStartTime,
      endTime: this.store.currentEndTime,
    }
  },
  watch: {
    'store.currentStartTime'() {
      this.startTime = this.store.currentStartTime
    },
    'store.currentEndTime'() {
      this.startTime = this.store.currentStartTime
    },
  },
  methods: {
    onFetchVideoImmediately() {
      const date = moment(this.store.currentDate).format('yyyy-MM-DD')
      const startTime = `${date} ${this.startTime}`
      const endTime = `${date} ${this.endTime}`
      const cameraIds = this.store.areaCameraIds(this.store.selectedAreaId)

      this.fetchVideos(cameraIds[0], startTime, endTime) 
    },
    openDialog() {
      this.onFetchVideoImmediately()
      this.isDialogActive = true
    },
    closeDialog() {
      this.isDialogActive = false
    },
    getTime(isoDate) {
      return moment(isoDate).format('HH:mm')
    },
  },
})
</script>
